#include <iostream>
#include <iomanip>
#include <fstream>
#include <ctime>
#include <vector>
#include <algorithm>
#include <iterator>
#include <string>
#include <cmath>

bool createDataFileStreams(const std::string& file) {
	srand(time(NULL));
	std::ofstream f (file, std::ios::out | std::ios::trunc);
	if (!f.is_open()) {
		throw std::exception("FILE NOT EXIST");
	}
	for (int i = 0; i < 100; ++i) {			
		f << rand() % 101 - 50 << "\n";
	}
	f.close();	
	return true;

}

bool createDataGenerateCopy(const std::string& file) {
	srand(time(NULL));
	std::ofstream f(file, std::ios::out | std::ios::trunc);
	std::vector<int> values(100);
	if (!f.is_open()) {
		throw std::exception("FILE NOT EXIST");
	}
	std::generate(values.begin(), values.end(), []() { 
			return (std::rand() % 101 - 50); 
		});	
	std::copy(values.begin(), values.end(), std::ostream_iterator<int>(f, "\n"));
	f.close();
	return true;
}

template<class container>
container loadDataFileStream(const std::string& file) {
	container res;
	std::ifstream f(file);
	if (!f.is_open()) {
		throw std::exception("FILE NOT EXIST");
	}
	int buf;
	while (f >> buf) {
		res.push_back(buf);
	}
	fin.close();
	return res;
}


template<class container>
container loadDataIterCopy(const std::string& file) {
	container res;
	std::ifstream f(file);
	if (!f.is_open()) {
		throw std::exception("FILE NOT EXIST");
	}
	std::copy(std::istream_iterator<int>(fin), std::istream_iterator<int>(), res.begin());
	return res;
}
